package java.util.function;

import java.util.Objects;
import java.util.Comparator;

@FunctionalInterface
public interface BinaryOperator<T> extends BiFunction<T, T, T>
{
    public static <T> BinaryOperator<T> minBy(Comparator<? super T> obj) {
        Objects.requireNonNull(obj);
        return (o, o2)/* java.lang.Object,java.lang.Object, */ -> (p0.compare(o, o2) <= 0) ? o : o2;
    }
    
    public static <T> BinaryOperator<T> maxBy(Comparator<? super T> obj) {
        Objects.requireNonNull(obj);
        return (o, o2)/* java.lang.Object,java.lang.Object, */ -> (p0.compare(o, o2) >= 0) ? o : o2;
    }
}
